//+------------------------------------------------------------------+
//|                                                           FA.mq4 |
//|                                          Copyright  2009, al_su |
//|                                                  al_su31@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, al_su"
#property link      "al_su31@mail.ru"
#include <stdlib.mqh>
#property indicator_separate_window
#property indicator_buffers 8
//---- input parameters
extern string    _1=".csv";
extern string    1="";
extern color     1=Red;
extern string    _2=".csv";
extern string    2="";
extern color     2=Orange;
extern string    _3=".csv";
extern string    3="";
extern color     3=Yellow;
extern string    _4=".csv";
extern string    4="";
extern color     4=Green;
extern string    _5=".csv";
extern string    5="";
extern color     5=DeepSkyBlue;
extern string    _6=".csv";
extern string    6="";
extern color     6=Blue;
extern string    _7=".csv";
extern string    7="";
extern color     7=Navy;
extern string    _8=".csv";
extern string    8="";
extern color     8=Magenta;
extern string    _="dd.mm.yyyy";
extern string    _=";";
extern string    ___=",";

//---- buffers
double FA1[];
double FA2[];
double FA3[];
double FA4[];
double FA5[];
double FA6[];
double FA7[];
double FA8[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
string id;
int init()
  {
   id=StringConcatenate("Fundamental data (id_",TimeLocal(),")");
   IndicatorShortName(id);
//---- indicators
   if(FileCanOpen(_1))
   {
      if(StringTrimLeft(StringTrimRight(1))=="")
         1=StringSubstr(_1,0,StringFind(_1,"."));
   }
   else 1="";      
   if(FileCanOpen(_2))
   {
   if(StringTrimLeft(StringTrimRight(2))=="")
      2=StringSubstr(_2,0,StringFind(_2,"."));
   }
   else 2="";      
   if(FileCanOpen(_3))
   {
   if(StringTrimLeft(StringTrimRight(3))=="")
      3=StringSubstr(_3,0,StringFind(_3,"."));
   }
   else 3="";      
   if(FileCanOpen(_4))
   {
   if(StringTrimLeft(StringTrimRight(4))=="")
      4=StringSubstr(_4,0,StringFind(_4,"."));
   }
   else 4="";      
   if(FileCanOpen(_5))
   {
   if(StringTrimLeft(StringTrimRight(5))=="")
      5=StringSubstr(_5,0,StringFind(_5,"."));
   }
   else 5="";      
   if(FileCanOpen(_6))
   {
   if(StringTrimLeft(StringTrimRight(6))=="")
      6=StringSubstr(_6,0,StringFind(_6,"."));
   }
   else 6="";      
   if(FileCanOpen(_6))
   {
   if(StringTrimLeft(StringTrimRight(7))=="")
      7=StringSubstr(_7,0,StringFind(_7,"."));
   }
   else 7="";      
   if(FileCanOpen(_8))
   {
   if(StringTrimLeft(StringTrimRight(8))=="")
      8=StringSubstr(_8,0,StringFind(_8,"."));
   }
   else 8="";      
      
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,1);
   SetIndexLabel(0,1);
   SetIndexBuffer(0,FA1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,2);
   SetIndexLabel(1,2);
   SetIndexBuffer(1,FA2);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1,3);
   SetIndexLabel(2,3);
   SetIndexBuffer(2,FA3);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1,4);
   SetIndexLabel(3,4);
   SetIndexBuffer(3,FA4);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1,5);
   SetIndexLabel(4,5);
   SetIndexBuffer(4,FA5);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1,6);
   SetIndexLabel(5,6);
   SetIndexBuffer(5,FA6);
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,1,7);
   SetIndexLabel(6,7);
   SetIndexBuffer(6,FA7);
   SetIndexStyle(7,DRAW_LINE,STYLE_SOLID,1,8);
   SetIndexLabel(7,8);
   SetIndexBuffer(7,FA8);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(WindowFind(id));
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   DrawData(_1,FA1,1,1);
   DrawData(_2,FA2,2,2);
   DrawData(_3,FA3,3,3);
   DrawData(_4,FA4,4,4);
   DrawData(_5,FA5,5,5);
   DrawData(_6,FA6,6,6);
   DrawData(_7,FA7,7,7);
   DrawData(_8,FA8,8,8);
//----
   return(0);
  }
//+------------------------------------------------------------------+
void DrawData(string file, double &FA[], string label, color C)
{
   int i,j,h;
   string date,val;
   h=FileOpen(file,FILE_READ|FILE_CSV,_);
   if(h>=0)
   {
      ArrayInitialize(FA,EMPTY_VALUE);
      FileSeek(h,0,SEEK_SET);
      while(!FileIsEnding(h))
      {
         date=FileReadString(h);
         val=FileReadString(h);
         if(___!=".") StringReplace(val,___,".");
         FA[iBarShift(0,0,StrToDate(date,_))]=StrToDouble(val);
      }
      FileClose(h);
      int max=0;
      for(i=0;i<Bars-1;i++)
         if(FA[i]!=EMPTY_VALUE) max=i;
      for(i=max-1;i>=0;i--)
      {
         if(FA[i]!=EMPTY_VALUE)
         {
            for(j=i+1;j<max;j++) FA[j]=FA[i]+((FA[max]-FA[i])/(max-i))*(j-i);
            max=i;
         }   
      }
      ObjectDelete(label); 
      ObjectCreate(label,OBJ_TEXT,WindowFind(id),Time[max],FA[max]);
      ObjectSetText(label,label,8,"",C);   
//      Alert(ErrorDescription(GetLastError()));
   }
}

void StringReplace(string &src, string old, string new)
{
   src=StringTrimLeft(StringTrimRight(src));
   old=StringTrimLeft(StringTrimRight(old));
   new=StringTrimLeft(StringTrimRight(new));
   int p;
   while(true)
   {
      p=StringFind(src,old);
      if(p==-1) break;
      src=StringConcatenate(StringSubstr(src,0,p),new,StringSubstr(src,p+StringLen(old)));
   }
}

bool IsNumeric(string c)
{
   int i=StringGetChar(c,0);
   return(i>=48&&i<=57);
}

datetime StrToDate(string src, string format)
{
   src=StringTrimLeft(StringTrimRight(src));
   format=StringTrimLeft(StringTrimRight(format));
   
   string sy="",sm="",sd="",sh="",si="";
   int pos=0,cv;
   string c,p;
   while(pos<StringLen(src))
   {
      c=StringSubstr(src,pos,1);
      p=StringSubstr(format,pos,1);
      
      if(p=="y")
      {
        if(IsNumeric(c)) sy=sy+c;
        else return(0);
      }
      else
      if(p=="m")
      {
        if(IsNumeric(c)) sm=sm+c;
        else return(0);
      }
      else
      if(p=="d")
      {
        if(IsNumeric(c)) sd=sd+c;
        else return(0);
      }  
      else
      if(p=="h")
      {
        if(IsNumeric(c)) sh=sh+c;
        else return(0);
      }
      else
      if(p=="i")
      {
        if(IsNumeric(c)) si=si+c;
        else return(0);
      }
      else 
      if(p!=c) return(0);
      pos++;
   }   
   string result;
   if(sy!=""&&sm!=""&&sd!="") result=StringConcatenate(sy,".",sm,".",sd);
   if(sh!=""&&si!="") result=StringConcatenate(result," ",sh,":",si);
   return(StrToTime(result));
}

bool FileCanOpen(string file)
{
   int h=FileOpen(file,FILE_READ|FILE_CSV,_);
   if(h>0) {FileClose(h);return(true);}
   return(false);
}